//+------------------------------------------------------------------+
//|                                                         Zmey.mq4 |
//|                                           Copyright 2015, NickAC |
//|                                               karabas_72@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, NickAC"
#property link      "karabas_72@mail.ru"
#property version   "1.00"
#property strict

input string  s____                       = " ";
input string  StartTime                   = "09:01:00";  //    
input string  EndTime                     = "15:00:00";  //    
extern double Lots                        = 50.0;        // 
extern string exptime                     = "5";         //  
extern int    magic                       = 963741;      //  
extern int    slippage                    = 3;           // 
extern int    max_trades                  = 3;           //    

extern string   Moving_Averages           = " Moving Averages";
extern int            InpMAPeriod         = 8;
extern int            InpMAShift          = 0;
extern ENUM_MA_METHOD InpMAMethod         = MODE_SMMA;

extern string   Envelopes                 = " Envelopes";
extern int    MA_Period                   = 40;
extern int    MA_Shift                    = 0;
extern ENUM_MA_METHOD MA_Method           = MODE_SMA;
extern ENUM_APPLIED_PRICE  Applied_Price  = PRICE_CLOSE;
extern double Deviation                   = 0.04;

extern string   MACD                      = " MACD";
extern int    InpFastEMA                  = 6;
extern int    InpSlowEMA                  = 20;
extern int    InpSignalSMA                = 4;

double PriceHigh,PriceLow,MacdCurrent,SignalCurrent,SignalMAPrevious,SignalMAThis,PriceCurrentOpen,PriceCurrentClose;
int    ticket;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
 if (Digits==3||Digits==5)
 {
  slippage*=10;
 }   
 return(INIT_SUCCEEDED);
} 
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
 datetime EaStartTime = StringToTime(StartTime);  //    
 datetime EaEndTime = StringToTime(EndTime);      //    
 datetime CurrTime = TimeCurrent();               //      
 if (CurrTime < EaStartTime || CurrTime >= EaEndTime)
  return;                                         //      - 
{
 PriceLow=iEnvelopes(NULL,0,MA_Period,MA_Shift,MA_Method,Applied_Price,Deviation,0,1);
 PriceHigh =iEnvelopes(NULL,0,MA_Period,MA_Shift,MA_Method,Applied_Price,Deviation,1,1);
 MacdCurrent=iMACD(NULL,0,InpFastEMA,InpSlowEMA,InpSignalSMA,PRICE_CLOSE,MODE_MAIN,0);
 SignalCurrent=iMACD(NULL,0,InpFastEMA,InpSlowEMA,InpSignalSMA,PRICE_CLOSE,MODE_SIGNAL,0);
 SignalMAPrevious=iMA(NULL,0,InpMAPeriod,InpMAShift,InpMAMethod,PRICE_MEDIAN,1);
 SignalMAThis=iMA(NULL,0,InpMAPeriod,InpMAShift,InpMAMethod,PRICE_MEDIAN,0);
 PriceCurrentOpen=iOpen(NULL,0,1);
 PriceCurrentClose=iClose(NULL,0,1);
  if (CountTrades()==0) CheckForOpen();
   else
  {
   if(CountTrades()<max_trades) CheckForOpen();
  }
 }
}  
void CheckForOpen()
{
//-----   .
 if(PriceCurrentOpen<PriceLow&&PriceCurrentOpen<PriceCurrentClose&&SignalCurrent<MacdCurrent&&SignalMAPrevious<SignalMAThis)
 {
  ticket=OrderSend(NULL,OP_BUY,Lots,Ask,slippage,0,0,"5",magic,0,Blue);
   if(ticket>0)
    return; 
 }
//-----   .
 if(PriceCurrentOpen>PriceLow&&PriceCurrentOpen>PriceCurrentClose&&SignalCurrent>MacdCurrent&&SignalMAPrevious>SignalMAThis)
 {
  ticket=OrderSend(NULL,OP_SELL,Lots,Bid,slippage,0,0,"5",magic,0,Red);
   if(ticket>0)
    return; 
 }
}
//+------------------------------------------------------------------+
int CountTrades ()
{
 int count=0;
 for (int i=OrdersTotal()-1;i>=0;i--)
 {
  if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
  {
   if(OrderSymbol()==Symbol()&&OrderMagicNumber()==magic)
    count++;
  }
 }
 return(count);
}
